api/urls.py
from django.urls import path
from api import views


app_name ="api"
urlpatterns = [
    
]

cplaest/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('api/', include("api.urls")),
    path('core/', include("core.urls")),
    path('', include("home.urls")),
]

home/urls.py
from django.urls import path
from home import views


app_name ="home"
urlpatterns = [
    path('', views.Index.as_view(), name="index"),
    path('signup/', views.SignUp.as_view(), name="signup"),
    path('logout/', views.LogOut.as_view(), name="logout"),
    path('about/', views.About.as_view(), name="about"),
    path('user_profile/', views.UserProfile.as_view(), name="user_profile"),
    path('identify/', views.Indentify.as_view(), name="identify"),
    path('contact/', views.contact.as_view(), name="contact"),
]

home/models.py
from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver

# Create your models here.


class UserProfile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    timestamp = models.DateField(auto_now_add=True, auto_now=False)
    updated = models.DateField(auto_now_add=False, auto_now=True)
    bio = models.CharField(max_length=256, default="i Love This APP")
    status = models.BooleanField(default=True)

    def __str__(self):
        return self.user.first_name


@receiver(post_save, sender=User)
def create_user_profile(sender, instance, created, *args, **kwargs):
    if created:
        UserProfile.objects.create(user=instance)
    instance.userprofile.save()

home/forms.py
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm
from django import forms

from .models import UserProfile


class LoginForm(forms.Form):
    username = forms.CharField(max_length=32, widget=forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Escribe tu username"}))
    password = forms.CharField(max_length=32, widget=forms.PasswordInput(attrs={"type":"password", "class":"form-control", "placeholder":"Escribe tu password"}))


class SignUpForm(UserCreationForm):
    username = forms.CharField(max_length=32, widget=forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Escribe tu username"}))
    password1 = forms.CharField(max_length=32, widget=forms.PasswordInput(attrs={"type":"password", "class":"form-control", "placeholder":"Escribe tu password"}))
    password2 = forms.CharField(max_length=32, widget=forms.PasswordInput(attrs={"type":"password", "class":"form-control", "placeholder":"Repite tu password"}))
    email = forms.CharField(max_length=32, widget=forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Escribe tu email"}))
    first_name = forms.CharField(max_length=32, widget=forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Escribe tu first_name"}))
    last_name = forms.CharField(max_length=32, widget=forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Escribe tu last_name"}))
    class Meta:
        model = User
        fields = [
            "username",
            "password1",
            "password2",
            "email",
            "first_name",
            "last_name"
           
        ]
        # widgets = {
        #     "username": forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Escribe tu username"}),
        #     "password": forms.PasswordInput(attrs={"type":"password", "class":"form-control", "placeholder":"Escribe tu password"}),
        #     "email": forms.EmailInput(attrs={"type":"email", "class":"form-control", "placeholder":"Escribe tu email"})
        # }



class UserProfileForm(forms.ModelForm):
    class Meta:
        model = UserProfile
        fields = [
            "user",
            "bio",
            "status"
        ]
        widgets = {
            "user": forms.Select(attrs={"type":"select", "class":"form-select"}),
            "bio": forms.Textarea(attrs={"type":"text", "class":"form-control", "placeholder":"Escribe acerca de ti", "row":3}),
            "status": forms.CheckboxInput(attrs={"type":"checkbox", "class":"form-checkbox"}),
        }

home/views.py
from django.forms.models import BaseModelForm
from django.http import HttpResponse
from django.shortcuts import render, redirect
from django.views import generic
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.models import User
from django.urls import reverse_lazy
from .forms import LoginForm, SignUpForm, UserProfileForm
from .models import UserProfile

# Create your views here.

class Index(generic.View):
    template_name = "home/index.html"
    context = {}
    form = LoginForm()

    def get(self, request):
        self.context = {
            "name": "José López",
            "lista": [1, 2, 3],
            "form": self.form
        }
        return render(request, self.template_name, self.context)
    
    def post(self, request):
        username = request.POST["username"]
        password = request.POST["password"]
        user = authenticate(request, username=username, password=password)
        if user is not None:
            login(request, user)
            return redirect("/")
        else:
            return redirect("/")

    
class LogOut(generic.View):
    def get(self, request):
        logout(request)
        return redirect("/")
    

class SignUp(generic.CreateView):
    template_name = "home/signup.html"
    form_class = SignUpForm
    success_url = reverse_lazy("home:index")

    def form_valid(self, form):
        form.save()
        username = form.cleaned_data.get("username")
        password1 = form.cleaned_data.get("password1")
        user = authenticate(self.request, username=username, password=password1)
        if user is not None:
            login(self.request, user)
        return redirect("/")




class UserProfile(LoginRequiredMixin, generic.CreateView):
    template_name = "home/user_profile.html"
    model = UserProfile
    form_class = UserProfileForm
    success_url = reverse_lazy("home:user_profile")
    login_url = "/"



class About(generic.View):
    template_name = "home/about.html"
    context = {}

    def get(self, request, *args, **kwargs):
        self.context = {
            "name": "josé lópez"
        }
        return render(request, self.template_name, self.context)


class Identity(generic.View):
    template_name = "home/identity.html"
    context = {}

    def get(self, request, *args, **kwargs):
        self.context = {
            "name": "José López"
        }
        return render(request, self.template_name, self.context)


class Contact(generic.View):
    template_name = "home/contact.html"
    context = {}

    def get(self, request, *args, **kwargs):
        self.context = {
            "name": "José"
        }
        return render(request, self.template_name, self.context)

    

class About(generic.View):
    template_name = "home/about.html"
    context = {}

    def get(self, request, *args, **kwargs):
        self.context = {
            "name": "José López"
        }
        return render(request, self.template_name, self.context)
     


class Indentify(generic.View):
    template_name = "home/identify.html"
    context = {}

    def get(self, request, *args, **kwargs):
        self.context = {
            "name": "José López"
        }
        return render(request, self.template_name, self.context)
    


class contact(generic.View):
    template_name = "home/contact.html"
    context = {}

    def get(self, request, *args, **kwargs):
        self.context = {
            "name": "José López"
        }
        return render(request, self.template_name, self.context)
    
    

templates/home/about.html
{% extends "base/base.html" %}

{% block tittle %} About view {% endblock tittle %}
{% block content %}
    <h1>Hola {{ request.user }} Bienvido a Django XD</h1>
    <button class="btn btn-outline-danger">TEST BOOTSTRAP</button>
    {% endblock content %}

templates/home/contact.html
{% extends "base/base.html" %}

{% block tittle %} contact view {% endblock tittle %}
{% block content %}
    <h1>Hola {{ request.user }} Bienvido a Django XD</h1>
    <button class="btn btn-outline-danger">TEST BOOTSTRAP</button>
    {% endblock content %}

templates/home/identify.html
{% extends "base/base.html" %}

{% block tittle %} identify view {% endblock tittle %}
{% block content %}
<h1>Hola {{ request.user }} Bienvido a Django XD</h1>
    <button class="btn btn-outline-danger">TEST BOOTSTRAP</button>
    {% endblock content %}
</html>

templates/home/index.html
{% extends "base/base.html" %}

{% block title %} Index View {% endblock title %}

{% block content %}
    {% if request.user.is_authenticated %}
    <a href="{% url 'home:logout' %}" class="btn btn-link">LogOut</a>
        <h1>Hola {{ request.user }} Bienvido a Django XD</h1>
        <button class="btn btn-outline-danger">Test Bootstrap</button>
        <br>
        <br><br>
        <br><br>
        <br>
        <br>
        <table class="table">
            {% for i in name %}
            <tr>
                <td>{{ name }}</td>
                <td>{{ name }}</td>
                <td>505</td>
            </tr>  
            {% endfor %}
        </table>
    {% else %}
        <form action="" method="post">
            {% csrf_token %}
                {{ form }}
                <br><hr>
                <button type="submit" class="btn btn-outline-success">LogIn</button>
                <br>
        </form>
        <p>
            Si no tienes una cuenta registrate <a href="{% url 'home:signup' %}" class="btn btn-link">aqui</a>
        </p>
    {% endif %}    
    
{% endblock content %}

templates/home/signup.html
{% extends "base/base.html" %}

{% block title %}
  SIGNUP VIEW
{% endblock title %}

{% block content %}
  <form action="" method="post" class="form">
    {% csrf_token %}
        {{ form }}
        <button type="submit" class="btn btn-outline-success form-control">Create a New User</button>
        <a href="{% url 'home:index' %}" class="btn btn-outline-warning form-control">Cancel</a>
  </form>
{% endblock content %}

templates/home/user_profile.html
{% extends "base/base.html" %}

{% block title %}
  USER PROFILE VIEW
{% endblock title %}

{% block content %}
   <form action="" method="post" class="form">
    {% csrf_token %}
        {{ form }}
        <button type="submit" class="btn btn-outline-success form-control">Create a New Profile</button>
        <a href="{% url 'home:index' %}" class="btn btn-outline-warning form-control">Cancel</a>
   </form>
{% endblock content %}